
import oracle.jsp.runtime.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import oracle.jsp.el.*;
import javax.servlet.jsp.el.*;
import javax.management.ObjectName;
import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import java.util.Set;
import com.tangosol.examples.jmx.JMXHelper;
import java.util.Map;
import com.tangosol.net.cache.WrapperNamedCache;
import com.tangosol.util.Filter;
import com.tangosol.util.aggregator.LongSum;
import com.tangosol.util.extractor.IdentityExtractor;


public class _clusterinfo extends com.orionserver.http.OrionHttpJspPage {


  // ** Begin Declarations


private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null,
                    new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree =
            (Long) new WrapperNamedCache(mapMemFreeResult, null)
                    .aggregate((Filter) null,
                            new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }

  // ** End Declarations

  public void _jspService(HttpServletRequest request, HttpServletResponse response) throws java.io.IOException, ServletException {

    response.setContentType( "text/html");
    /* set up the intrinsic variables using the pageContext goober:
    ** session = HttpSession
    ** application = ServletContext
    ** out = JspWriter
    ** page = this
    ** config = ServletConfig
    ** all session/app beans declared in globals.jsa
    */
    PageContext pageContext = JspFactory.getDefaultFactory().getPageContext( this, request, response, null, true, JspWriter.DEFAULT_BUFFER, true);
    // Note: this is not emitted if the session directive == false
    HttpSession session = pageContext.getSession();
    int __jsp_tag_starteval;
    ServletContext application = pageContext.getServletContext();
    JspWriter out = pageContext.getOut();
    _clusterinfo page = this;
    ServletConfig config = pageContext.getServletConfig();
    javax.servlet.jsp.el.VariableResolver __ojsp_varRes = (VariableResolver)new OracleVariableResolverImpl(pageContext);

    try {


      out.write(__oracle_jsp_text[0]);
      out.write(__oracle_jsp_text[1]);
      out.write(__oracle_jsp_text[2]);
      
              String sCacheName = "demo";
              CacheFactory.ensureCluster();
      
              // create JMXHelper
              JMXHelper helper = new JMXHelper();
      
              // find cluster MBean
              // null can bew replaced by domain name
              ObjectName cluster = helper.getClusterObjectName(null);
      
              // find all storage enabled nodes, by asking for the parents of
              // the StorageManagers
      
              // null can be replaced by cache
              Set setStorage = helper.getStorageManagerSet(null);
              Set setNodesStorage = helper.getParentNodeSet(setStorage);
      
              Long[] aLMem = getMemoryCapacity(helper, setNodesStorage);
              long lUsed = aLMem[0].longValue() - aLMem[1].longValue();
          
      out.write(__oracle_jsp_text[3]);
      out.print( setNodesStorage.size());
      out.write(__oracle_jsp_text[4]);
      out.print( aLMem[0]);
      out.write(__oracle_jsp_text[5]);
      
                  NamedCache cache = CacheFactory.getCache(sCacheName);
              
      out.write(__oracle_jsp_text[6]);
      out.print( cache.size());
      out.write(__oracle_jsp_text[7]);

    }
    catch (Throwable e) {
      if (!(e instanceof javax.servlet.jsp.SkipPageException)){
        try {
          if (out != null) out.clear();
        }
        catch (Exception clearException) {
        }
        pageContext.handlePageException(e);
      }
    }
    finally {
      OracleJspRuntime.extraHandlePCFinally(pageContext, true);
      JspFactory.getDefaultFactory().releasePageContext(pageContext);
    }

  }
  private static final char __oracle_jsp_text[][]=new char[8][];
  static {
    try {
    __oracle_jsp_text[0] = 
    "<html>\n".toCharArray();
    __oracle_jsp_text[1] = 
    "\n\n".toCharArray();
    __oracle_jsp_text[2] = 
    "\n\n\n<head>\n    <link href=\"layout.css\" rel=\"stylesheet\" type=\"text/css\">\n    <script type=\"text/javascript\" src=\"js/prototype.js\"></script>\n</head>\n\n<body>\n<center>\n    ".toCharArray();
    __oracle_jsp_text[3] = 
    "\n\n    <table class=\"double\">\n        <thead>\n            <th class=\"header\" colspan=\"2\">Coherence Data Grid Overview:</th>\n        </thead>\n        <tr>\n            <td class=\"header\">Storage Nodes:</td>\n            <td class=\"content\">\n                <font class=\"boldred\">".toCharArray();
    __oracle_jsp_text[4] = 
    "</font>\n            </td>\n        </tr>\n        <tr>\n            <td class=\"header\">Cluster Memory (MB):</td>\n            <td class=\"content\">\n                <font class=\"boldred\">".toCharArray();
    __oracle_jsp_text[5] = 
    "</font>\n            </td>\n        </tr>\n        ".toCharArray();
    __oracle_jsp_text[6] = 
    "\n\n        <tr>\n            <td class=\"header\">Data Grid Objects:</td>\n            <td class=\"content\">\n                <font class=\"boldred\">".toCharArray();
    __oracle_jsp_text[7] = 
    "</font>\n            </td>\n        </tr>\n    </table>\n</center>\n\n</body>\n</html>".toCharArray();
    }
    catch (Throwable th) {
      System.err.println(th);
    }
}
}
