<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@ page import="java.io.*,com.tangosol.net.*"%>
<%@ page contentType="text/html;charset=windows-1252"%>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=windows-1252"/>
    <title>Environment Check</title>
    <link type="text/css" rel="stylesheet" href="layout.css"/>
  </head>
  <body>
    <p>Checking the&nbsp;container&nbsp;for&nbsp;all&nbsp;the&nbsp;correct environment configuration</p><p>
      JVM OPTIONS Should be (cacheconfig path may vary):
    </p><p>-Dtangosol.coherence.management=all -Dtangosol.coherence.managment.remote=true -Dtangosol.coherence.cacheconfig=%DEMO_HOME%\etc\demo-config.xml -Dtangosol.coherence.distributed.localstorage=false</p>
    <% 
        String localStorageProp = System.getProperty("tangosol.coherence.distributedlocalstorage"); 
        String manageProp = System.getProperty("tangosol.coherence.management");
        String manageAllProp = System.getProperty("tangosol.coherence.management.all");
        String cacheConfigPath = System.getProperty("tangosol.coherence.cacheconfig");
        File configFile = new File(cacheConfigPath);
        boolean canRead = false;
        boolean configExists = configFile.exists();
        boolean cacheLoaded = false;
        if (configExists) {
            canRead = configFile.canRead();
        }
        
        CacheFactory.ensureCluster();
        NamedCache cache = CacheFactory.getCache("demo"); 
        int cacheSize =  0;
        try {
            cacheSize =  cache.size();
            //should be storage not set operation....
        } catch (RuntimeException re) {    
            re.printStackTrace(System.out);
        }
        
        if (cacheSize > 0) {
            cacheLoaded = true;
        }
        
    %>
    <p>Is tangosol.coherence.distributed.localstorage set properly? <%= "false".equals(localStorageProp) %></p><p>
      &nbsp;
    </p><p>Is tangosol.coherence.management set properly? <%= "true".equals(manageProp) %></p><p>
      &nbsp;
    </p><p>Is tangosol.coherence.management.all set properly? <%= "true".equals(manageAllProp) %></p><p>
      &nbsp;
    </p><p>Where is the path to my cache config file set to? <%= cacheConfigPath %></p><p>
      &nbsp;
    </p><p>Can this JSP&nbsp;find the config file? <%= configExists %>
    <p>
      &nbsp;
    </p><p>Can this JSP have read access to the config file? <%=canRead %>
    
    <p>
      &nbsp;
    </p><p>Have you loaded the Cache with Sample data? <%= cacheLoaded %></p><p>
      <% if (!cacheLoaded) {%>
    </p><p>
      &nbsp;
    </p><p>
      Please run the following command &gt;ant run-load-data from your 
      <strong>DEMO_HOME</strong>
       directory</p>
    <%} %>
  </body>
</html>