<%@ page import="javax.management.MBeanServer,
                 javax.management.ObjectName,
                 com.tangosol.examples.jmx.JMXHelper,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.List,
                 java.util.ArrayList,
                 java.util.Collections,
                 java.util.Set" %>
<%@ page import="java.util.HashSet"%>


<table class="double">
    <thead>Cache Clients (i.e. LocalStorage is <b>disabled</b>)</thead>
    <tr>
        <td class="header">Node ID</td>
        <td class="header">Unicast Identifier</td>
        <td class="header">Machine ID</td>
    </tr>

<%
try
    {
    JMXHelper helper = new JMXHelper();
    MBeanServer server = helper.getServer();
    ObjectName cluster = helper.getClusterObjectName(null /*domain name*/);

    // find all node MBeans
    Set setNodes = helper.getNodeSet(cluster);
    Set setStorage = helper.getStorageManagerSet(null /*cache*/);

    // find all storage enabled nodes, by asking for the parents of
    // the StorageManagers
    Set setNodesStorage = helper.getParentNodeSet(setStorage);

    Set setNodesStorageDisabled = new HashSet(setNodes);
    setNodesStorageDisabled.removeAll(setNodesStorage);

    List listNodesStorageDisabled = new ArrayList(setNodesStorageDisabled);
    Collections.sort(listNodesStorageDisabled,
            new JMXHelper.ObjectNameComparator("nodeId"));

    Collections.sort(listNodesStorageDisabled, new JMXHelper.ObjectNameComparator("nodeId"));

    for (int i = 0; i < listNodesStorageDisabled.size(); i++)
        {
        ObjectName node = (ObjectName) listNodesStorageDisabled.get(i);

%>
    <tr>
    <td class="content"><%= server.getAttribute(node, "Id")%></td>
    <td class="content"><%= server.getAttribute(node, "UnicastAddress")%>:<%= server.getAttribute(node, "UnicastPort")%></td>
    <td class="content"><%= server.getAttribute(node, "MachineId")%></td>
    </tr>
<%
        }
    }
catch (Exception e) {}

%>
</table>
