
import oracle.jsp.runtime.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import oracle.jsp.el.*;
import javax.servlet.jsp.el.*;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import java.util.ArrayList;
import java.util.List;
import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import java.util.Set;
import com.tangosol.examples.jmx.JMXHelper;
import java.util.Iterator;
import java.util.Map;
import com.tangosol.net.cache.WrapperNamedCache;
import com.tangosol.util.Filter;
import com.tangosol.util.aggregator.LongSum;
import com.tangosol.util.extractor.IdentityExtractor;
import java.util.HashSet;
import java.util.Collections;


public class _index__full extends com.orionserver.http.OrionHttpJspPage {


  // ** Begin Declarations


private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree = (Long) new WrapperNamedCache(mapMemFreeResult, null)
            .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }

  // ** End Declarations

  public void _jspService(HttpServletRequest request, HttpServletResponse response) throws java.io.IOException, ServletException {

    response.setContentType( "text/html");
    /* set up the intrinsic variables using the pageContext goober:
    ** session = HttpSession
    ** application = ServletContext
    ** out = JspWriter
    ** page = this
    ** config = ServletConfig
    ** all session/app beans declared in globals.jsa
    */
    PageContext pageContext = JspFactory.getDefaultFactory().getPageContext( this, request, response, null, true, JspWriter.DEFAULT_BUFFER, true);
    // Note: this is not emitted if the session directive == false
    HttpSession session = pageContext.getSession();
    int __jsp_tag_starteval;
    ServletContext application = pageContext.getServletContext();
    JspWriter out = pageContext.getOut();
    _index__full page = this;
    ServletConfig config = pageContext.getServletConfig();
    javax.servlet.jsp.el.VariableResolver __ojsp_varRes = (VariableResolver)new OracleVariableResolverImpl(pageContext);

    try {


      out.write(__oracle_jsp_text[0]);
      out.write(__oracle_jsp_text[1]);
      out.write(__oracle_jsp_text[2]);
      out.write(__oracle_jsp_text[3]);
      
          String sName = "demo";
          CacheFactory.ensureCluster();
      
          // create JMXHelper
          JMXHelper helper = new JMXHelper();
      
          // find cluster MBean
          ObjectName cluster = helper.getClusterObjectName(null /*domain name*/);
      
          // find all node MBeans
          Set setNodes = helper.getNodeSet(cluster);
          Set setStorage = helper.getStorageManagerSet(null /*cache*/);
      
          // find all storage enabled nodes, by asking for the parents of
          // the StorageManagers
          Set setNodesStorage = helper.getParentNodeSet(setStorage);
      
          Set setNodesStorageDisabled = new HashSet(setNodes);
          setNodesStorageDisabled.removeAll(setNodesStorage);
      
          List listNodesStorageDisabled = new ArrayList(setNodesStorageDisabled);
          Collections.sort(listNodesStorageDisabled, new JMXHelper.ObjectNameComparator("nodeId"));
      
          Long[] aLMem = getMemoryCapacity(helper, setNodesStorage);
          long   lUsed = aLMem[0].longValue() - aLMem[1].longValue();
          
      out.write(__oracle_jsp_text[4]);
      out.print( setNodes.size());
      out.write(__oracle_jsp_text[5]);
      out.print( aLMem[0]);
      out.write(__oracle_jsp_text[6]);
      out.print( lUsed);
      out.write(__oracle_jsp_text[7]);
      out.print(aLMem[1]);
      out.write(__oracle_jsp_text[8]);

    }
    catch (Throwable e) {
      if (!(e instanceof javax.servlet.jsp.SkipPageException)){
        try {
          if (out != null) out.clear();
        }
        catch (Exception clearException) {
        }
        pageContext.handlePageException(e);
      }
    }
    finally {
      OracleJspRuntime.extraHandlePCFinally(pageContext, true);
      JspFactory.getDefaultFactory().releasePageContext(pageContext);
    }

  }
  private static final char __oracle_jsp_text[][]=new char[9][];
  static {
    try {
    __oracle_jsp_text[0] = 
    "<html>\n".toCharArray();
    __oracle_jsp_text[1] = 
    "\n".toCharArray();
    __oracle_jsp_text[2] = 
    "\n\n".toCharArray();
    __oracle_jsp_text[3] = 
    "\n\n\n<head>\n    <title>Tangosol Coherence Demo</title>\n    <link href=\"layout.css\" rel=\"stylesheet\" type=\"text/css\">\n    <script type=\"text/javascript\" src=\"js/prototype.js\"></script>\n</head>\n\n    <body>\n    <center>\n        <table>\n            <tr>\n                <td class=\"banner\">\n                    <img src=\"images/tangosol_coherence_demo_banner.png\"\n                         alt=\"Tangosol Coherence Demo\"/><br>\n                </td>\n            </tr>\n        </table>\n    ".toCharArray();
    __oracle_jsp_text[4] = 
    "\n\n    <b>Cluster Information:</b><br>\n\n    Nodes in the cluster: ".toCharArray();
    __oracle_jsp_text[5] = 
    "<br>\n    Memory: Total: ".toCharArray();
    __oracle_jsp_text[6] = 
    " Used: ".toCharArray();
    __oracle_jsp_text[7] = 
    " Free: ".toCharArray();
    __oracle_jsp_text[8] = 
    "<br>\n\n    <br>\n    <b>Node Information:</b>\n    <br>\n    <div align=\"center\">\n        <table>\n            <tr>\n                <td>\n                    <div id=\"clients\" align=\"left\">\n                        Loading...\n                    </div>\n                    <script type=\"text/javascript\">\n                        new Ajax.PeriodicalUpdater($('clients'),\n                                \"renderclients.jsp\", {\n                            frequency: 1,\n                            onSuccess: function()\n                                {\n                                Element.setOpacity('updatesponsor', 0.0);\n                                Effect.Appear('updatesponsor', { duration: 2.0 });\n                                }\n                        }\n                                );\n                    </script>\n                </td>\n                <td>\n                    <div id=\"servers\" align=\"right\">\n                        Loading...\n                    </div>\n                    <script type=\"text/javascript\">\n                        new Ajax.PeriodicalUpdater($('servers'),\n                                \"renderservers.jsp\", {\n                            frequency: 1,\n                            onSuccess: function()\n                                {\n                                Element.setOpacity('updatesponsor', 0.0);\n                                Effect.Appear('updatesponsor', { duration: 2.0 });\n                                }\n                        }\n                                );\n                    </script>\n                </td>\n            </tr>\n            <tr>\n                <td>\n                    <div id=\"datadistribution\" align=\"left\">\n                        Loading...\n                    </div>\n                    <script type=\"text/javascript\">\n                        new Ajax.PeriodicalUpdater($('datadistribution'),\n                                \"rendernodesdata.jsp\", {\n                            frequency: 1,\n                            onSuccess: function()\n                                {\n                                Element.setOpacity('updatesponsor', 0.0);\n                                Effect.Appear('updatesponsor', { duration: 2.0 });\n                                }\n                        }\n                                );\n                    </script>\n                </td>\n                <td>\n                    <div id=\"distinct\" align=\"left\">\n                        Loading...\n                    </div>\n                    <script type=\"text/javascript\">\n                        new Ajax.PeriodicalUpdater($('distinct'),\n                                \"distinct.jsp\", {\n                            frequency: 1,\n                            onSuccess: function()\n                                {\n                                Element.setOpacity('updatesponsor', 0.0);\n                                Effect.Appear('updatesponsor', { duration: 2.0 });\n                                }\n                        }\n                                );\n                    </script>\n                </td>\n            </tr>\n        </table>\n\n    </div>\n    <br>\n    <b>Data Distribution:</b>\n    <br>\n\n    <br>\n    </center>\n\n    </body>\n</html>".toCharArray();
    }
    catch (Throwable th) {
      System.err.println(th);
    }
}
}
