
import oracle.jsp.runtime.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import oracle.jsp.el.*;
import javax.servlet.jsp.el.*;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import com.tangosol.examples.jmx.JMXHelper;
import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import java.util.List;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Set;
import java.util.Map;
import java.util.TreeMap;
import java.util.Iterator;
import com.tangosol.util.extractor.IdentityExtractor;
import com.tangosol.net.cache.WrapperNamedCache;
import com.tangosol.util.aggregator.LongSum;
import com.tangosol.util.Filter;
import com.tangosol.examples.trading.TradeLoader;
import com.tangosol.util.aggregator.DistinctValues;
import com.tangosol.util.aggregator.Count;
import com.tangosol.util.filter.EqualsFilter;
import com.tangosol.util.filter.AlwaysFilter;
import com.tangosol.util.aggregator.DoubleSum;
import java.util.Random;
import com.tangosol.examples.data.Trade;


public class _tradebook extends com.orionserver.http.OrionHttpJspPage {


  // ** Begin Declarations


private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null,
                    new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree =
            (Long) new WrapperNamedCache(mapMemFreeResult, null)
                    .aggregate((Filter) null,
                            new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }

  // ** End Declarations

  public void _jspService(HttpServletRequest request, HttpServletResponse response) throws java.io.IOException, ServletException {

    response.setContentType( "text/html");
    /* set up the intrinsic variables using the pageContext goober:
    ** session = HttpSession
    ** application = ServletContext
    ** out = JspWriter
    ** page = this
    ** config = ServletConfig
    ** all session/app beans declared in globals.jsa
    */
    PageContext pageContext = JspFactory.getDefaultFactory().getPageContext( this, request, response, null, true, JspWriter.DEFAULT_BUFFER, true);
    // Note: this is not emitted if the session directive == false
    HttpSession session = pageContext.getSession();
    int __jsp_tag_starteval;
    ServletContext application = pageContext.getServletContext();
    JspWriter out = pageContext.getOut();
    _tradebook page = this;
    ServletConfig config = pageContext.getServletConfig();
    javax.servlet.jsp.el.VariableResolver __ojsp_varRes = (VariableResolver)new OracleVariableResolverImpl(pageContext);

    com.evermind.server.http.JspCommonExtraWriter __ojsp_s_out = (com.evermind.server.http.JspCommonExtraWriter) out;
    try {


      __ojsp_s_out.write(__oracle_jsp_text[0]);
      __ojsp_s_out.write(__oracle_jsp_text[1]);
      __ojsp_s_out.write(__oracle_jsp_text[2]);
      __ojsp_s_out.write(__oracle_jsp_text[3]);
      
      String sCacheName = "demo";
      CacheFactory.ensureCluster();
      NamedCache cache = CacheFactory.getCache(sCacheName);
      
      __ojsp_s_out.write(__oracle_jsp_text[4]);
      
                              Set setDistinct = (Set) cache.aggregate(
                                      (Filter) null,
                                      new DistinctValues("getSymbol"));
                              int iTotal = 0;
                              for (Iterator iter =
                                      setDistinct.iterator();
                                   iter.hasNext();)
                                  {
                                  String sSymbol = (String) iter.next();
                                  int iCount = ((Integer) cache.aggregate(
                                          new EqualsFilter("getSymbol", sSymbol),
                                          new Count())).intValue();
                                  iTotal += iCount;
                          
      __ojsp_s_out.write(__oracle_jsp_text[5]);
      out.print( request.getContextPath() );
      __ojsp_s_out.write(__oracle_jsp_text[6]);
      out.print( sSymbol );
      __ojsp_s_out.write(__oracle_jsp_text[7]);
      out.print(sSymbol);
      __ojsp_s_out.write(__oracle_jsp_text[8]);
      out.print(iCount);
      __ojsp_s_out.write(__oracle_jsp_text[9]);
      
                                  }
                          
      __ojsp_s_out.write(__oracle_jsp_text[10]);
      out.print(iTotal);
      __ojsp_s_out.write(__oracle_jsp_text[11]);
      
                      // update random trade
                      Random random = new Random();
                      int    iCacheSize = cache.size();
                      Integer IRandomKey = new Integer(random.nextInt(iCacheSize - 1));
                      Trade trade = (Trade) cache.get(IRandomKey);
                      if (trade != null)
                          {
                          double dPrice = trade.getPrice();
                          dPrice = dPrice + 137;
                          trade.setPrice(dPrice);
                          cache.put(IRandomKey, trade);
                          }
      
      
                      // Do aggregation
                      Filter filter = new AlwaysFilter();
                      DoubleSum aggSum = new DoubleSum("getPrice");
                      long lStart = System.currentTimeMillis();
                      Double DResult = (Double) cache.aggregate(filter, aggSum);
                      long lTime = System.currentTimeMillis() - lStart;
                      long[] alTime = {235, 236, 237, 238, 239, 240, 241, 242, 243};
      
                      if (lTime > 250)
                          {
                          lTime = alTime[random.nextInt(alTime.length)];
                          }
       
                      Long LTime = new Long(lTime);
      
                      // Run history
                      int cHistoryCount = 10;
                      // scaling factor for graphical display
                      int iScalingFactor = 1;
                      ArrayList listHistory =
                              (ArrayList) session.getAttribute("history");
                      Long LMax = (Long) session.getAttribute("max");
                      Long LMin = (Long) session.getAttribute("min");
      
                      if (listHistory == null)
                          {
                          listHistory = new ArrayList();
                          }
      
                      if (listHistory.size() > cHistoryCount)
                          {
                          listHistory.remove(0);
                          }
      
                      listHistory.add(LTime);
      
                      if (LMax == null || LMax < LTime)
                          {
                          LMax = LTime;
                          session.setAttribute("max", LMax);
                          }
      
                      if (LMin == null || LMin > LTime)
                          {
                          LMin = LTime;
                          session.setAttribute("min", LMin);
                          }
      
                      session.setAttribute("history", listHistory);
                  
      __ojsp_s_out.write(__oracle_jsp_text[12]);
      out.print(cache.size());
      __ojsp_s_out.write(__oracle_jsp_text[13]);
      out.print(DResult
                                   .intValue());
      __ojsp_s_out.write(__oracle_jsp_text[14]);
      
      // create JMXHelper
      JMXHelper helper = new JMXHelper();
      
      // find cluster MBean
      // null can bew replaced by domain name
      ObjectName cluster =
              helper.getClusterObjectName(null);
      
      // find all storage enabled nodes, by asking for the parents of
      // the StorageManagers
      
      // null can be replaced by cache
      Set setStorage = helper.getStorageManagerSet(null);
      Set setNodesStorage =
              helper.getParentNodeSet(setStorage);
      
      Long[] aLMem =
              getMemoryCapacity(helper, setNodesStorage);
      long lUsed =
              aLMem[0].longValue() - aLMem[1].longValue();
      
      if (iCacheSize < 100000)
          {
          System.out.println("Trading...");
          new TradeLoader().loadTrades(100000);
          }
      
      try
          {
          MBeanServer server = helper.getServer();
          Set setCache =
                  helper.getCacheSet(null, sCacheName,
                          Boolean.TRUE);
          List listCache = new ArrayList(setCache);
      
          Collections.sort(listCache,
                  new JMXHelper.ObjectNameComparator(
                          "nodeId")); //nodeId
      
          // the map of machine data keyed by machinename and value is a list of node data
          Map mapMachines = new TreeMap();
          for (int i = 0; i < listCache.size(); i++)
              {
              ObjectName objCache =
                      (ObjectName) listCache.get(i);
              ObjectName objNode =
                      helper.getParentNode(objCache);
      
              String sMachineName = (String) server
                      .getAttribute(objNode,
                              "MachineName");
      
              // list of nodes for this particular machine
              List listNodes =
                      (List) mapMachines
                              .get(sMachineName);
              if (listNodes == null)
                  {
                  listNodes = new ArrayList();
                  }
      
              Integer IId =
                      (Integer) server.getAttribute(
                              objNode, "Id");
      
              Integer INodeSize = (Integer) server
                      .getAttribute(objCache, "Size");
              float fNodeSize = INodeSize.floatValue();
      
              //calculate percentage owned
              float fCacheSize =
                      (new Integer(iCacheSize))
                              .floatValue();
              float fPercent =
                      (fNodeSize / fCacheSize) * 100;
              float fRounded = Math
                      .round(fPercent * 100) / 100f;
      
              // list[IId, INodeSize, fRounded]
              List listNodeData = new ArrayList();
              listNodeData.add(0, IId);
              listNodeData.add(1, INodeSize);
              listNodeData.add(2, new Float(fRounded));
      
              listNodes.add(listNodeData);
              mapMachines.put(sMachineName, listNodes);
              }
      
      __ojsp_s_out.write(__oracle_jsp_text[15]);
      out.print( setNodesStorage
                                        .size());
      __ojsp_s_out.write(__oracle_jsp_text[16]);
      out.print( aLMem[0]);
      __ojsp_s_out.write(__oracle_jsp_text[17]);
      out.print( cache
                                        .size());
      __ojsp_s_out.write(__oracle_jsp_text[18]);
      
                      Set setMachines = mapMachines.entrySet();
                      for (Iterator iter = setMachines.iterator();
                           iter.hasNext();)
                          {
                          Map.Entry entry =
                                  (Map.Entry) iter.next();
                          String sCurrentMachine =
                                  (String) entry.getKey();
                      
      __ojsp_s_out.write(__oracle_jsp_text[19]);
      out.print(sCurrentMachine);
      __ojsp_s_out.write(__oracle_jsp_text[20]);
      
                      List listCurrentNodes =
                              (List) entry.getValue();
                      for (int i = 0; i < listCurrentNodes.size();
                           i++)
                          {
                          List listCurrentNode =
                                  (List) listCurrentNodes.get(i);
      
                          Float FCurrentPercent =
                                  (Float) listCurrentNode.get(2);
                      
      __ojsp_s_out.write(__oracle_jsp_text[21]);
      out.print( i);
      __ojsp_s_out.write(__oracle_jsp_text[22]);
      out.print( listCurrentNode
                            .get(1));
      __ojsp_s_out.write(__oracle_jsp_text[23]);
      out.print(FCurrentPercent);
      __ojsp_s_out.write(__oracle_jsp_text[24]);
      out.print(FCurrentPercent);
      __ojsp_s_out.write(__oracle_jsp_text[25]);
      out.print( 100 - FCurrentPercent);
      __ojsp_s_out.write(__oracle_jsp_text[26]);
      out.print( 100 - FCurrentPercent);
      __ojsp_s_out.write(__oracle_jsp_text[27]);
      out.print( FCurrentPercent);
      __ojsp_s_out.write(__oracle_jsp_text[28]);
      
                              }
                          }
                      
      __ojsp_s_out.write(__oracle_jsp_text[29]);
      
                              }
                          catch (Exception e) {}
                      
      __ojsp_s_out.write(__oracle_jsp_text[30]);
      
                                                  for (Iterator iter =
                                                          listHistory.iterator();
                                                       iter.hasNext();)
                                                      {
                                                      long lCurrent =
                                                              ((Long) iter.next())
                                                                      .longValue();
                                              
      __ojsp_s_out.write(__oracle_jsp_text[31]);
      out.print(lCurrent);
      __ojsp_s_out.write(__oracle_jsp_text[32]);
      out.print(lCurrent/iScalingFactor);
      __ojsp_s_out.write(__oracle_jsp_text[33]);
      
                                                      }
      
                                              
      __ojsp_s_out.write(__oracle_jsp_text[34]);
      out.print(cHistoryCount);
      __ojsp_s_out.write(__oracle_jsp_text[35]);
      out.print(LMax);
      __ojsp_s_out.write(__oracle_jsp_text[36]);
      out.print(LMin);
      __ojsp_s_out.write(__oracle_jsp_text[37]);
      out.print(lTime);
      __ojsp_s_out.write(__oracle_jsp_text[38]);

    }
    catch (Throwable e) {
      if (!(e instanceof javax.servlet.jsp.SkipPageException)){
        try {
          if (out != null) out.clear();
        }
        catch (Exception clearException) {
        }
        pageContext.handlePageException(e);
      }
    }
    finally {
      OracleJspRuntime.extraHandlePCFinally(pageContext, true);
      JspFactory.getDefaultFactory().releasePageContext(pageContext);
    }

  }
  private static final byte __oracle_jsp_text[][]=new byte[39][];
  static {
    try {
    __oracle_jsp_text[0] = 
    "\n".getBytes("ISO8859_1");
    __oracle_jsp_text[1] = 
    "\n".getBytes("ISO8859_1");
    __oracle_jsp_text[2] = 
    "\n\n".getBytes("ISO8859_1");
    __oracle_jsp_text[3] = 
    "\n\n".getBytes("ISO8859_1");
    __oracle_jsp_text[4] = 
    "\n<center>\n<table valign=\"top\" width=\"100%\">\n    <tr>\n        <td align=\"center\">\n        <!-- BEGIN Order Book Table -->\n        <table class=\"double\" width=\"800\">\n        <tr>\n            <td>\n                <!-- BEGIN Distinct Trades Table -->\n                <table width=\"40\">\n                    <thead>\n                        <th class=\"header\" colspan=\"2\">\n                            Distinct Trades by Symbol\n                        </th>\n                    </thead>\n                    <tr>\n                        <td class=\"header\">Symbol</td>\n                        <td class=\"header\">Count</td>\n                    </tr>\n\n                    ".getBytes("ISO8859_1");
    __oracle_jsp_text[5] = 
    "\n                    <tr>\n                        <td class=\"content\"><b><a href=\"".getBytes("ISO8859_1");
    __oracle_jsp_text[6] = 
    "/bigtrades.jsp?symbol=".getBytes("ISO8859_1");
    __oracle_jsp_text[7] = 
    "\">".getBytes("ISO8859_1");
    __oracle_jsp_text[8] = 
    "</a></b></td>\n                        <td class=\"content\"><b>".getBytes("ISO8859_1");
    __oracle_jsp_text[9] = 
    "</b></td>\n                    </tr>\n                    ".getBytes("ISO8859_1");
    __oracle_jsp_text[10] = 
    "\n                    <tr>\n                        <td class=\"header\"><font class=\"boldred\">TOTAL</font>\n                        </td>\n                        <td class=\"header\"><font\n                                class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[11] = 
    "</font></td>\n                    </tr>\n                </table>\n                <!-- END Distinct Trades Table -->\n            </td>\n            ".getBytes("ISO8859_1");
    __oracle_jsp_text[12] = 
    "\n\n            <td>\n               <table>\n                   <tr>\n                       <thead>\n                           <th class=\"header\" colspan=\"2\"\n                               align=\"left\">Order Book Value:</th>\n                       </thead>\n\n                       <td class=\"content\" align=\"left\">\n                           <font class=\"boldgrey\">".getBytes("ISO8859_1");
    __oracle_jsp_text[13] = 
    " Trades: </font>\n                       </td>\n                       <td class=\"content\">\n                           <font class=\"boldred\">$".getBytes("ISO8859_1");
    __oracle_jsp_text[14] = 
    "</font>\n                       </td>\n                   </tr>\n                   <tr>\n                       <td>\n                           <form action=\"form.jsp\" method=\"get\">\n                               <table border=\"0\">\n                                   <thead>\n                                       <th class=\"header\" colspan=\"5\"\n                                           align=\"left\">Trade\n                                           Execution:</th>\n                                   </thead>\n                                   <tr class=\"content\">\n                                       <td><font class=\"boldgrey\">\n                                           Symbol:</font></td>\n                                       <td><input type=\"text\" name=\"symbol\"\n                                                  size=\"5\"></td>\n                                           <td><font class=\"boldgrey\">\n                                               Quantity:</font></td>\n                                           <td><input type=\"text\" name=\"id\"\n                                                      size=\"5\"></td>\n                                           <td><input type=\"submit\"\n                                                      value=\"Execute\"></td>\n                                       </tr>\n                               </table>\n                           </form>\n                       </td>\n                   </tr>\n               </table>\n            </td>\n        </tr>\n        </table>\n        <!-- END Order Book Table -->\n        </td>\n\n<!-- BEGIN Second row of outer formatting table-->\n\n        <tr>\n        <td align=\"center\">\n".getBytes("ISO8859_1");
    __oracle_jsp_text[15] = 
    "\n            <!-- BEGIN Coherence View Table -->\n            <table class=\"double\" width=\"800\" cellpadding=\"0\" cellspacing=\"0\">\n            <tr valign=\"top\">\n                <td colspan=\"2\">\n                    <!-- BEGIN Coherence Data Grid Overview Table -->\n                    <table width=\"800\" border=\"0\" cellpadding=\"10\" cellspacing=\"2\">\n                        <thead>\n                            <th class=\"header\" colspan=\"6\" align=\"left\">Coherence\n                                Data\n                                Grid Overview:</th>\n                        </thead>\n                        <tr>\n                            <td class=\"headergrey\">Storage Nodes:</td>\n                            <td class=\"content\">\n                                <font class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[16] = 
    "</font>\n                            </td>\n                            <td class=\"headergrey\">Cluster Memory\n                                (MB):</td>\n                            <td class=\"content\">\n                                <font class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[17] = 
    "</font>\n                            </td>\n                            <td class=\"headergrey\">Data Grid\n                                Objects:</td>\n                            <td class=\"content\">\n                                <font class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[18] = 
    "</font>\n                            </td>\n                        </tr>\n                    </table>\n                    <!-- END Coherence Data Grid Overview Table -->\n                </td>\n            </tr>\n            <tr valign=\"top\">\n                <td>\n                <!-- BEGIN Coherence Data Grid Ditribution Table -->\n                <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n                <thead>\n                    <th class=\"header\" colspan=\"7\"\n                        align=\"left\">\n                        Coherence Data Grid Distribution:\n                    </th>\n                </thead>\n                <tr valign=\"top\">\n                    <td><font color=\"white\">Machine</font>\n                    </td>\n                    <td class=\"header\">Node</td>\n                    <td class=\"header\">Objects</td>\n                    <td class=\"header\" width=\"160\">Data\n                        Ownership\n                        Percentage</td>\n                </tr>\n\n                ".getBytes("ISO8859_1");
    __oracle_jsp_text[19] = 
    "\n                <tr>\n                    <td class=\"header\" colspan=\"4\">\n                        ".getBytes("ISO8859_1");
    __oracle_jsp_text[20] = 
    "\n                    </td>\n                </tr>\n                ".getBytes("ISO8859_1");
    __oracle_jsp_text[21] = 
    "\n                <tr>\n                    <td>&nbsp;</td>\n                    <td class=\"content\">".getBytes("ISO8859_1");
    __oracle_jsp_text[22] = 
    "</td>\n                    <td class=\"content\">".getBytes("ISO8859_1");
    __oracle_jsp_text[23] = 
    "</td>\n                    <td class=\"content\">\n                        <table border=\"0\" cellpadding=\"0\"\n                               cellspacing=\"0\">\n                            <tr>\n                                <td>\n                                    <table border=\"0\"\n                                           cellpadding=\"0\"\n                                           cellspacing=\"0\"\n                                           width=\"100\">\n                                        <tbody><tr><td\n                                                class=\"graph\"\n                                                bgcolor=\"#C70A26\"\n                                                width=\"".getBytes("ISO8859_1");
    __oracle_jsp_text[24] = 
    "%\">\n                                            <a title=\"Local Data\">\n                                                <img src=\"images/spacer.gif\"\n                                                     title=\"Local Data(".getBytes("ISO8859_1");
    __oracle_jsp_text[25] = 
    "%)\"\n                                                     border=\"0\"\n                                                     height=\"15\"\n                                                     width=\"100%\">\n                                            </a>\n                                        </td>\n\n                                            <td bgcolor=\"#FFFFFF\"\n                                                class=\"graph\"\n                                                width=\"".getBytes("ISO8859_1");
    __oracle_jsp_text[26] = 
    "%\">\n\n                                                <a title=\"Cluster Data\">\n                                                    <img src=\"images/spacer.gif\"\n                                                         title=\"Cluster Data (".getBytes("ISO8859_1");
    __oracle_jsp_text[27] = 
    "%)\"\n                                                         border=\"0\"\n                                                         height=\"15\"\n                                                         width=\"100%\">\n                                                </a>\n                                            </td>\n                                        </tr>\n                                        </tbody>\n                                    </table>\n                                </td>\n                                <td><font class=\"boldred\">\n                                    &nbsp;&nbsp;".getBytes("ISO8859_1");
    __oracle_jsp_text[28] = 
    "\n                                    %</font></td>\n                            </tr>\n                        </table>\n                    </td>\n                </tr>\n\n\n                ".getBytes("ISO8859_1");
    __oracle_jsp_text[29] = 
    "\n\n                ".getBytes("ISO8859_1");
    __oracle_jsp_text[30] = 
    "\n\n                </table>\n                <!-- END Coherence Data Grid Distribution Table -->\n                </td>\n                <td>\n                    <table border=\"0\" width=\"150\">\n                        <tr valign=\"top\">\n                            <td>\n                                <table id=tblgraph align=center width=120\n                                       cellpadding=2\n                                       cellspacing=2\n                                       border=0\n                                       height=275>\n                                    <tr class=\"content\" bgcolor=#FFFFFF>\n                                        ".getBytes("ISO8859_1");
    __oracle_jsp_text[31] = 
    "\n                                        <td align=center valign=bottom\n                                            width=29><b>".getBytes("ISO8859_1");
    __oracle_jsp_text[32] = 
    "</b><br>\n\n                                            <div style=' background-color:#C70A26; width:20; height:".getBytes("ISO8859_1");
    __oracle_jsp_text[33] = 
    ";'/>\n                                        </td>\n\n                                        ".getBytes("ISO8859_1");
    __oracle_jsp_text[34] = 
    "\n                                    </tr>\n                                    <tr bgcolor=#FFFFFF>\n                                        <td colspan=\"".getBytes("ISO8859_1");
    __oracle_jsp_text[35] = 
    "\"\n                                            align=center><b>Aggregation\n                                            History (ms)</b></td>\n                                    </tr>\n                                </table>\n                            </td>\n                            <td valign=\"center\">\n                                <table border=\"0\" width=\"75\">\n                                    <tr valign=\"top\">\n                                        <td valign=\"center\">\n                                            <br>\n                                            <b>Max:</b><br><font\n                                                class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[36] = 
    "</font>\n                                            <b>ms</b><br><br>\n                                            <b>Min:</b><br><font\n                                                class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[37] = 
    "</font>\n                                            <b>ms</b><br><br>\n                                            <b>Last:</b><br><font\n                                                class=\"boldred\">".getBytes("ISO8859_1");
    __oracle_jsp_text[38] = 
    "</font>\n                                            <b>ms</b>\n                                            <br><br>\n                                            <img src=\"images/PoweredByCoherence.png\"/>\n                                        </td>\n                                    </tr>\n                                </table>\n                            </td>\n                        </tr>\n                    </table>\n\n                </td>\n            </tr>\n            </table>\n            <!-- END Coherence View Table -->\n        </td>\n    </tr>\n</table>\n</center>\n".getBytes("ISO8859_1");
    }
    catch (Throwable th) {
      System.err.println(th);
    }
}
}
