<html>
<%@ page import="javax.management.ObjectName,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.Set,
                 com.tangosol.examples.jmx.JMXHelper,
                 java.util.Map,
                 com.tangosol.net.cache.WrapperNamedCache,
                 com.tangosol.util.extractor.IdentityExtractor,
                 com.tangosol.util.Filter,
                 com.tangosol.util.aggregator.LongMin"%>
<%@ page import="com.tangosol.util.aggregator.ComparableMin"%>

<head>
    <link href="layout.css" rel="stylesheet" type="text/css">
    <script type="text/javascript" src="js/prototype.js"></script>
</head>

<body>
<center>
    <%
        CacheFactory.ensureCluster();

        // create JMXHelper
        JMXHelper helper = new JMXHelper();

        // find cluster MBean
        ObjectName cluster = helper.getClusterObjectName(null /*domain name*/);

        // find all node MBeans
        Set setNodes = helper.getNodeSet(cluster);
        // Set setStorage = helper.getStorageManagerSet(null /*cache*/);
        Map  mapPubSucc  = helper.getAttributeAll(setNodes, "PublisherSuccessRate");
        
    %>

    <table class="double">
        <thead>
            <th class="header" colspan="2">
                Coherence Cluster/DataGrid Information:
            </th>
        </thead>
        <tr>
            <td class="header">
                Nodes in the cluster:
            </td>
            <td class="content">
                <%= setNodes.size()%>
            </td>
        </tr>
        <tr>
            <td class="header">
                Min:
            </td>
            <td class="content">
                <%-- = LLowPubSucc --%>
            </td>
        </tr>
    </table>
</center>

</body>
</html>