<%@ page import="javax.management.MBeanServer,
                 javax.management.ObjectName,
                 com.tangosol.examples.jmx.JMXHelper,
                 java.util.List,
                 java.util.ArrayList,
                 java.util.Collections,
                 java.util.Set,
                 java.util.HashSet" %>


<table class="double">
    <thead>Cache Servers (i.e. LocalStorage is <b>enabled</b>)</thead>
    <tr>
        <td class="header">Node Id</td>
        <td class="header">Unicast Identifier</td>
        <td class="header">Machine Id</td>
    </tr>

    <%
        try
            {
            JMXHelper helper = new JMXHelper();
            MBeanServer server = helper.getServer();

            // find all node MBeans
            Set setStorage = helper.getStorageManagerSet(null /*cache*/);

            // find all storage enabled nodes, by asking for the parents of
            // the StorageManagers
            Set setNodesStorage = helper.getParentNodeSet(setStorage);

            List listNodesStorage =
                    new ArrayList(setNodesStorage);
            Collections.sort(listNodesStorage,
                    new JMXHelper.ObjectNameComparator("nodeId"));

            for (int i = 0; i < listNodesStorage.size(); i++)
                {
                ObjectName node = (ObjectName) listNodesStorage.get(i);

    %>
    <tr>
        <td class="content"><%= server.getAttribute(node, "Id")%></td>
        <td class="content"><%= server.getAttribute(node, "UnicastAddress")%>
            :<%= server.getAttribute(node, "UnicastPort")%></td>
        <td class="content"><%= server.getAttribute(node, "MachineId")%></td>
    </tr>
    <%
                }
            }
        catch (Exception e) {}

    %>
</table>
